
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>学习Java中的日期和时间处理及Java日历小程序的编写_java / iVAN</title>

    <meta name="description" content="学习Java中的日期和时间处理及Java日历小程序的编写_java Java 在 java.util 包中提供了 Date 类,这个类封装了当前的日期和时间. Date 类支持两种构造函数.第一个构造函数初始化对象的当前日期和时间. Date( )下面的构造函数接收一个参数等于自1970年1月1日午夜起已经过的毫秒数 Date(long millisec) 一旦有一个可用的日期对象,可以调用以下任何一种支持的方法使用时间: SN 方法和描述 1 boolean after(Date date) 如果调用Date对象包含或晚于指定的日期则返回true,否则,返回f">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">学习Java中的日期和时间处理及Java日历小程序的编写_java</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Java 在 java.util 包中提供了 Date 类，这个类封装了当前的日期和时间。</p>
<p>Date 类支持两种构造函数。第一个构造函数初始化对象的当前日期和时间。</p>
<p><strong>Date( )<br /></strong>下面的构造函数接收一个参数等于自1970年1月1日午夜起已经过的毫秒数</p>
<pre>
Date(long millisec)
</pre>
<p>一旦有一个可用的日期对象，可以调用以下任何一种支持的方法使用时间：</p>
<table>
<thead>
<tr>
<th>SN</th>
<th>方法和描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>1</td>
<td>boolean after(Date date)<br />
      如果调用Date对象包含或晚于指定的日期则返回true，否则，返回false。</td>
</tr>
<tr>
<td>2</td>
<td>boolean before(Date date)<br />
      如果调用Date对象包含或早于日期指定的日期返回true，否则，返回false。</td>
</tr>
<tr>
<td>3</td>
<td>Object clone( )<br />
      重复调用Date对象。</td>
</tr>
<tr>
<td>4</td>
<td>int compareTo(Date date)<br />
      调用对象的值与日期比较。如果这两个值相等返回0。如果调用对象是早于日期返回一个负值。如果调用对象迟于日期返回正值。</td>
</tr>
<tr>
<td>5</td>
<td>int compareTo(Object obj)<br />
      以相同的compareTo(Date)操作 如果obj是一个类日期。否则，它会抛出一个ClassCastException。</td>
</tr>
<tr>
<td>6</td>
<td>boolean equals(Object date)<br />
      如果调用Date对象包含相同的时间及日期指定日期则返回true，否则，返回false。</td>
</tr>
<tr>
<td>7</td>
<td>long getTime( )<br />
      返回自1970年1月1日起已经过的毫秒数。</td>
</tr>
<tr>
<td>8</td>
<td>int hashCode( )<br />
      返回调用对象的哈希代码。</td>
</tr>
<tr>
<td>9</td>
<td>void setTime(long time)<br />
      设置所指定的时间，这表示从1970年1月1日从午夜的时间和日期以毫秒为单位经过的时间。</td>
</tr>
<tr>
<td>10</td>
<td>String toString( )<br />
      调用Date对象转换为字符串，并返回结果。</td>
</tr>
</tbody>
</table>
<p><strong>获取当前日期和时间<br /></strong>在 Java 中容易得到当前的日期和时间。可以使用一个简单的 Date 对象的 toString() 方法，如下所示打印当前日期和时间：</p>
<pre>
import java.util.Date;

public class DateDemo {
  public static void main(String args[]) {
    // Instantiate a Date object
    Date date = new Date();

    // display time and date using toString()
    System.out.println(date.toString());
  }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Mon May 04 09:51:52 CDT 2009
</pre>
<p><strong>日期比较<br /></strong>有以下三种方式来比较两个日期：</p>
<ul>
<li>可以使用 getTime() 来获得自1970年1月1日午夜十二时起已经过的毫秒数，然后比较两个对象的值。</li>
<li>可以使用 before( ), after( ), 和 equals( ) 方法，由于12日在18日前，例如， new Date(99, 2, 12).before(new Date (99, 2, 18)) 返回值为 true。</li>
<li>可以使用 compareTo() 方法，这是由 Comparable 接口定义，由 Date 实现。</li>
</ul>
<p><strong>使用 SimpleDateFormat 格式化日期</strong></p>
<p>SimpleDateFormat 是一个具体的类，以本地方式用于格式化和转换日期。SimpleDateFormat 允许选择用户定义的模式为日期时间格式。例如：</p>
<pre>
import java.util.*;
import java.text.*;

public class DateDemo {
  public static void main(String args[]) {

   Date dNow = new Date( );
   SimpleDateFormat ft =
   new SimpleDateFormat ("E yyyy.MM.dd 'at' hh:mm:ss a zzz");

   System.out.println("Current Date: " + ft.format(dNow));
  }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Current Date: Sun 2004.07.18 at 04:14:09 PM PDT
</pre>
<p><strong>简单的 DateFormat 格式代码<br /></strong>要指定时间格式，使用时间模式字符串。在这个模式中，所有的 ASCII 字母被保留为模式字母，其定义如下：</p>
<table>
<thead>
<tr>
<th>字符</th>
<th>描述</th>
<th>例子</th>
</tr>
</thead>
<tbody>
<tr>
<td>G</td>
<td>时代指示器</td>
<td>AD</td>
</tr>
<tr>
<td>y</td>
<td>四位数年份</td>
<td>2001</td>
</tr>
<tr>
<td>M</td>
<td>年中的月份</td>
<td>July or 07</td>
</tr>
<tr>
<td>d</td>
<td>月份中日期</td>
<td>10</td>
</tr>
<tr>
<td>h</td>
<td>时间 A.M./P.M.(1~12)</td>
<td>12</td>
</tr>
<tr>
<td>H</td>
<td>天中的小时 (0~23)</td>
<td>22</td>
</tr>
<tr>
<td>m</td>
<td>小时中的分钟</td>
<td>30</td>
</tr>
<tr>
<td>s</td>
<td>分钟中的秒钟</td>
<td>55</td>
</tr>
<tr>
<td>S</td>
<td>毫秒</td>
<td>234</td>
</tr>
<tr>
<td>E</td>
<td>星期中的天</td>
<td>Tuesday</td>
</tr>
<tr>
<td>D</td>
<td>年中的天</td>
<td>360</td>
</tr>
<tr>
<td>F</td>
<td>月中星期中的天</td>
<td>2 (second Wed. in July)</td>
</tr>
<tr>
<td>w</td>
<td>年中的星期</td>
<td>40</td>
</tr>
<tr>
<td>W</td>
<td>月中的星期</td>
<td>1</td>
</tr>
<tr>
<td>a</td>
<td>A.M./P.M. 标记</td>
<td>PM</td>
</tr>
<tr>
<td>k</td>
<td>天中的小时(1~24)</td>
<td>24</td>
</tr>
<tr>
<td>K</td>
<td>小时A.M./P.M. (0~11)</td>
<td>10</td>
</tr>
<tr>
<td>z</td>
<td>时区</td>
<td>东部标准时间</td>
</tr>
<tr>
<td>'</td>
<td>脱离文本</td>
<td>分隔符</td>
</tr>
<tr>
<td>"</td>
<td>单引号</td>
<td>`</td>
</tr>
</tbody>
</table>
<p><strong>用 printf 格式化日期<br /></strong>日期和时间格式用 printf 方法可以非常轻松地做到。可以使用两个字母的格式，从 t 开始并在下面给出的表格中的其中一个字母结束。例如：</p>
<pre>
import java.util.Date;

public class DateDemo {

 public static void main(String args[]) {
   // Instantiate a Date object
   Date date = new Date();

   // display time and date using toString()
   String str = String.format("Current Date/Time : %tc", date );

   System.out.printf(str);
 }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Current Date/Time : Sat Dec 15 16:37:57 MST 2012
</pre>
<p>如果提供日期多次格式化是一种不好的做法。一个格式字符串可以指示要格式化的参数的索引。<br />
索引必须紧跟在 ％ 之后，并必须由 $ 终止。例如：</p>
<pre>
import java.util.Date;

public class DateDemo {

  public static void main(String args[]) {
    // Instantiate a Date object
    Date date = new Date();

    // display time and date using toString()
    System.out.printf("%1$s %2$tB %2$td, %2$tY",
             "Due date:", date);
  }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Due date: February 09, 2004
</pre>
<p>或者，也可以使用 &lt; 标志。则表示相同的参数，根据前述格式规范，应再次使用。例如：</p>
<pre>
import java.util.Date;

public class DateDemo {

  public static void main(String args[]) {
    // Instantiate a Date object
    Date date = new Date();

    // display formatted date
    System.out.printf("%s %tB %&lt;te, %&lt;tY",
             "Due date:", date);
  }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Due date: February 09, 2004
</pre>
<p><strong>日期和时间转换字符<br /></strong></p>
<table>
<thead>
<tr>
<th>字符</th>
<th>描述</th>
<th>例子</th>
</tr>
</thead>
<tbody>
<tr>
<td>c</td>
<td>完整的日期和时间</td>
<td>Mon May 04 09:51:52 CDT 2009</td>
</tr>
<tr>
<td>F</td>
<td>ISO 8601 日期</td>
<td>2004-02-09</td>
</tr>
<tr>
<td>D</td>
<td>U.S. 格式时间 (月/日/年)</td>
<td>02/09/2004</td>
</tr>
<tr>
<td>T</td>
<td>24-时制</td>
<td>18:05:19</td>
</tr>
<tr>
<td>r</td>
<td>12-时制</td>
<td>06:05:19 pm</td>
</tr>
<tr>
<td>R</td>
<td>24-时制，无秒</td>
<td>18:05</td>
</tr>
<tr>
<td>Y</td>
<td>四位数年份 (用前行零列)</td>
<td>2004</td>
</tr>
<tr>
<td>y</td>
<td>年份的后两位数(用前行零列)</td>
<td>04</td>
</tr>
<tr>
<td>C</td>
<td>年份的前两位(用前行零列)</td>
<td>20</td>
</tr>
<tr>
<td>B</td>
<td>完整月份名称</td>
<td>February</td>
</tr>
<tr>
<td>b</td>
<td>缩写月份名称</td>
<td>Feb</td>
</tr>
<tr>
<td>m</td>
<td>两位数月份 (用前行零列)</td>
<td>02</td>
</tr>
<tr>
<td>d</td>
<td>两位数日期 (用前行零列)</td>
<td>03</td>
</tr>
<tr>
<td>e</td>
<td>两位数日期(无前行零列)</td>
<td>9</td>
</tr>
<tr>
<td>A</td>
<td>完整星期名称</td>
<td>Monday</td>
</tr>
<tr>
<td>a</td>
<td>缩写星期名称</td>
<td>Mon</td>
</tr>
<tr>
<td>j</td>
<td>年中的三位数天数(用前行零列)</td>
<td>069</td>
</tr>
<tr>
<td>H</td>
<td>两位数小时(用前行零列), 00 和 23之间</td>
<td>18</td>
</tr>
<tr>
<td>k</td>
<td>两位数小时(无前行零列), 0 和 23 之间</td>
<td>18</td>
</tr>
<tr>
<td>I</td>
<td>两位数小时 (用前行零列), 01和12之间</td>
<td>06</td>
</tr>
<tr>
<td>l</td>
<td>两位数小时 (无前行零列), 1 和12之间</td>
<td>6</td>
</tr>
<tr>
<td>M</td>
<td>两位数分钟 (用前行零列)</td>
<td>05</td>
</tr>
<tr>
<td>S</td>
<td>两位数秒钟(用前行零列)</td>
<td>19</td>
</tr>
<tr>
<td>L</td>
<td>三位数毫秒（用前行零列)</td>
<td>047</td>
</tr>
<tr>
<td>N</td>
<td>九位数纳秒 (用前行零列)</td>
<td>047000000</td>
</tr>
<tr>
<td>P</td>
<td>大写上下午标记</td>
<td>PM</td>
</tr>
<tr>
<td>p</td>
<td>小写上下午标记</td>
<td>pm</td>
</tr>
<tr>
<td>z</td>
<td>RFC 822 从GMT数字抵消</td>
<td>-0800</td>
</tr>
<tr>
<td>Z</td>
<td>时区</td>
<td>PST</td>
</tr>
<tr>
<td>s</td>
<td>从 1970-01-01 00:00:00 的秒数GMT</td>
<td>1078884319</td>
</tr>
<tr>
<td>Q</td>
<td>从 1970-01-01 00:00:00 的毫秒数GMT</td>
<td>1078884319047</td>
</tr>
</tbody>
</table>
<p>有相关的日期和时间等有用的类。欲了解更多详细信息，可以参考 Java 标准文档。<br />
<br /><strong>字符串转换日期<br /></strong>SimpleDateFormat 类有一些额外的方法，如 parse()，它试图根据存储在给定 SimpleDateFormat 的对象的格式来转换字符串。例如：</p>
<pre>
import java.util.*;
import java.text.*;

public class DateDemo {

  public static void main(String args[]) {
   SimpleDateFormat ft = new SimpleDateFormat ("yyyy-MM-dd"); 

   String input = args.length == 0 ? "1818-11-11" : args[0]; 

   System.out.print(input + " Parses as "); 

   Date t; 

   try {
     t = ft.parse(input);
     System.out.println(t);
   } catch (ParseException e) {
     System.out.println("Unparseable using " + ft);
   }
  }
}
</pre>
<p>上述程序的运行示例将产生以下结果：</p>
<pre>
$ java DateDemo
1818-11-11 Parses as Wed Nov 11 00:00:00 GMT 1818
$ java DateDemo 2007-12-01
2007-12-01 Parses as Sat Dec 01 00:00:00 GMT 2007
</pre>
<p><strong>休眠一段时间<br /></strong>你可以进行任何期间的时间休眠，从一毫秒直到你的电脑的整个生命周期。例如，下面的程序会休眠10秒：</p>
<pre>
import java.util.*;

public class SleepDemo {
  public static void main(String args[]) {
   try {
     System.out.println(new Date( ) + "\n");
     Thread.sleep(5*60*10);
     System.out.println(new Date( ) + "\n");
   } catch (Exception e) {
     System.out.println("Got an exception!");
   }
  }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Sun May 03 18:04:41 GMT 2009

Sun May 03 18:04:51 GMT 2009
</pre>
<p><strong>测量执行时间<br /></strong>有时候，可能需要测量的时间点以毫秒为单位。因此，让我们再一次重新写上面的例子:</p>
<pre>
import java.util.*;

public class DiffDemo {

  public static void main(String args[]) {
   try {
     long start = System.currentTimeMillis( );
     System.out.println(new Date( ) + "\n");
     Thread.sleep(5*60*10);
     System.out.println(new Date( ) + "\n");
     long end = System.currentTimeMillis( );
     long diff = end - start;
     System.out.println("Difference is : " + diff);
   } catch (Exception e) {
     System.out.println("Got an exception!");
   }
  }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Sun May 03 18:16:51 GMT 2009

Sun May 03 18:16:57 GMT 2009

Difference is : 5993
</pre>
<p><strong>GregorianCalendar 类<br /></strong>GregorianCalendar 是一个 Calendar 类具体的实现，即你所熟悉的对正常 Gregorian 公历的实现。本教程中不讨论 Calendar 类，可以看看标准 Java 文档。</p>
<p>Calendar 的 getInstance() 方法返回与当前日期和时间默认语言环境和时区初始化的一个 GregorianCalendar。 GregorianCalendar 中定义了两个字段：AD 和 BC。这些代表在公历中定义的两个时代。</p>
<p>也有几个构造函数的 GregorianCalendar 对象：</p>
<table>
<thead>
<tr>
<th>SN</th>
<th>构造函数描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>1</td>
<td>GregorianCalendar() <br />
      在默认时区与默认语言环境使用当前时间构造默认的GregorianCalendar。</td>
</tr>
<tr>
<td>2</td>
<td>GregorianCalendar(int year, int month, int date) <br />
      在默认时区设置默认的语言环境用给定的日期构造一个GregorianCalendar</td>
</tr>
<tr>
<td>3</td>
<td>GregorianCalendar(int year, int month, int date, int hour, int minute) <br />
      用给定的日期和时间设置为与默认语言环境的默认时区构造一个GregorianCalendar。</td>
</tr>
<tr>
<td>4</td>
<td>GregorianCalendar(int year, int month, int date, int hour, int minute, int second) <br />
      用给定的日期和时间设置为与默认语言环境的默认时区构造一个 GregorianCalendar</td>
</tr>
<tr>
<td>5</td>
<td>GregorianCalendar(Locale aLocale) <br />
      基于当前时间与给定语言环境的默认时区构建一个GregorianCalendar。</td>
</tr>
<tr>
<td>6</td>
<td>GregorianCalendar(TimeZone zone) <br />
      基于当前时间，使用默认的语言环境在给定的时区构建一个GregorianCalendar。</td>
</tr>
<tr>
<td>7</td>
<td>GregorianCalendar(TimeZone zone, Locale aLocale) <br />
      基于当前时间与给定语言环境的给定时区构建一个GregorianCalendar。</td>
</tr>
</tbody>
</table>
<p>这里是由 GregorianCalendar 类提供的一些有用的方法的列表：<br />
<table>
<thead>
<tr>
<th>SN</th>
<th>方法和描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>1</td>
<td>void add(int field, int amount) <br />
      基于日历的规则，以给定的时间字段添加指定（有符号的）时间量。</td>
</tr>
<tr>
<td>2</td>
<td>protected void computeFields() <br />
      将UTC转换为毫秒时间字段值.</td>
</tr>
<tr>
<td>3</td>
<td>protected void computeTime() <br />
      覆盖日历转换时间域值为UTC的毫秒.</td>
</tr>
<tr>
<td>4</td>
<td>boolean equals(Object obj) <br />
      这个GregorianCalendar与一个对象引用比较.</td>
</tr>
<tr>
<td>5</td>
<td>int get(int field) <br />
      获取给定时间域的值.</td>
</tr>
<tr>
<td>6</td>
<td>int getActualMaximum(int field) <br />
      返回该字段可能的最大值，给定到当前的日期.</td>
</tr>
<tr>
<td>7</td>
<td>int getActualMinimum(int field) <br />
      返回该字段可能具有的最小值，给定当前的日期.</td>
</tr>
<tr>
<td>8</td>
<td>int getGreatestMinimum(int field) <br />
      对于给定的字段中返回高最低值（如果有变化）.</td>
</tr>
<tr>
<td>9</td>
<td>Date getGregorianChange() <br />
      获取公历更改日期.</td>
</tr>
<tr>
<td>10</td>
<td>int getLeastMaximum(int field) <br />
      对于给定的字段返回最低的最大值，如果有变化.</td>
</tr>
<tr>
<td>11</td>
<td>int getMaximum(int field) <br />
      返回给定字段中的最大值.</td>
</tr>
<tr>
<td>12</td>
<td>Date getTime() <br />
      获取日历的当前时间.</td>
</tr>
<tr>
<td>13</td>
<td>long getTimeInMillis() <br />
      获取日历的当前时间长.</td>
</tr>
<tr>
<td>14</td>
<td>TimeZone getTimeZone() <br />
      获取时区.</td>
</tr>
<tr>
<td>15</td>
<td>int getMinimum(int field) <br />
      返回给定字段中的最小值.</td>
</tr>
<tr>
<td>16</td>
<td>int hashCode() <br />
      重写hashCode.</td>
</tr>
<tr>
<td>17</td>
<td>boolean isLeapYear(int year) <br />
      确定给定年份是闰年.</td>
</tr>
<tr>
<td>18</td>
<td>void roll(int field, boolean up) <br />
      加上或减去（上/下）的时间在给定的时间字段一个单元，不更改更大的字段.</td>
</tr>
<tr>
<td>19</td>
<td>void set(int field, int value) <br />
      设置时间字段与给定值.</td>
</tr>
<tr>
<td>20</td>
<td>void set(int year, int month, int date) <br />
      设置为年，月，日的值.</td>
</tr>
<tr>
<td>21</td>
<td>void set(int year, int month, int date, int hour, int minute) <br />
      设置为年，月，日，小时和分钟值.</td>
</tr>
<tr>
<td>22</td>
<td>void set(int year, int month, int date, int hour, int minute, int second) <br />
      设置为字段的年，月，日，小时，分钟和秒的值.</td>
</tr>
<tr>
<td>23</td>
<td>void setGregorianChange(Date date) <br />
      设置GregorianCalendar更改日期.</td>
</tr>
<tr>
<td>24</td>
<td>void setTime(Date date) <br />
      设置日历的当前时间与给定日期.</td>
</tr>
<tr>
<td>25</td>
<td>void setTimeInMillis(long millis) <br />
      从给定long值设置日历的当前时间.</td>
</tr>
<tr>
<td>26</td>
<td>void setTimeZone(TimeZone value) <br />
      将时区设置与给定的时区值.</td>
</tr>
<tr>
<td>27</td>
<td>String toString() <br />
      返回此日历的字符串表示形式.</td>
</tr>
</tbody>
</table>
<p>示例</p>
<pre>
import java.util.*;

public class GregorianCalendarDemo {

  public static void main(String args[]) {
   String months[] = {
   "Jan", "Feb", "Mar", "Apr",
   "May", "Jun", "Jul", "Aug",
   "Sep", "Oct", "Nov", "Dec"};

   int year;
   // Create a Gregorian calendar initialized
   // with the current date and time in the
   // default locale and timezone.
   GregorianCalendar gcalendar = new GregorianCalendar();
   // Display current time and date information.
   System.out.print("Date: ");
   System.out.print(months[gcalendar.get(Calendar.MONTH)]);
   System.out.print(" " + gcalendar.get(Calendar.DATE) + " ");
   System.out.println(year = gcalendar.get(Calendar.YEAR));
   System.out.print("Time: ");
   System.out.print(gcalendar.get(Calendar.HOUR) + ":");
   System.out.print(gcalendar.get(Calendar.MINUTE) + ":");
   System.out.println(gcalendar.get(Calendar.SECOND));

   // Test if the current year is a leap year
   if(gcalendar.isLeapYear(year)) {
     System.out.println("The current year is a leap year");
   }
   else {
     System.out.println("The current year is not a leap year");
   }
  }
}
</pre>
<p>这将产生以下结果:</p>
<pre>
Date: Apr 22 2009
Time: 11:25:27
The current year is not a leap year
</pre>
<p><strong>日历小程序</strong></p>
<p>下面我们来看一个日历小程序。这里用传统的MVC结构，设计3个类：CalendarViewer、CalendarControlller、CalendarModel。<br />
CalendarViewer.java主要处理UI，沿用了已有代码，整理之并抽出业务逻辑，使其专注于显示层处理。<br />
CalendarViewer.java</p>
<pre>
public class CalendarViewer extends JWindow implements ActionListener {
  JPanel calendarYmPanel = null;
  JButton leftButton = new JButton("&lt;&lt;");
  JButton rightButton = new JButton("&gt;&gt;");
  Label yearLabel = new Label();
  Label monthLabel = new Label();
  Label passedDaysLabel = new Label();
  JPanel calendarWdPanel = null;// 是caledar_week和calendar_days的总包容体
  JPanel calendarWeekPanel = null;// 针对周列的布局
  JPanel calendarDaysPanel = null;// 针对日期列的布局
  JPanel calendarExitPanel = null;
  JButton quitButton = new JButton("关闭");
  Border emptyBorder = BorderFactory.createEmptyBorder();

  CalendarController cController = new CalendarController();

  public CalendarViewer() {
    super();
    buildUI();
  }

  public void buildUI() {
    buildTopPanel();
    buildCenterPanel();
    buildBottomPanel();
    setLayout(new BorderLayout());
    。。。。。。
  }

  private void buildTopPanel() {。。。。。。}

  private void buildCenterPanel() {。。。。。。}

  private void buildBottomPanel() {。。。。。。}

  public JPanel updateDaysPanel() {。。。。。。}

  public void updatePassedDaysLabel() {。。。。。。}

  public void actionPerformed(ActionEvent e) {。。。。。。}

  public static void main(String[] args) {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
       new CalendarViewer();
      }
    });
  }
}
</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MjE5OTAyNTMzNjYuanBn.jpg"></p>
<p>UI构造主要分3块，对应图上中下3个panel。</p>
<ul>
<li>buildTopPanel();</li>
<li>buildCenterPanel();</li>
<li>buildBottomPanel();</li>
</ul>
<p>事件监听的处理由下面方法完成。</p>
<ul>
<li>actionPerformed(ActionEvent e);</li>
</ul>
<p>基于事件的UI更新由以下两个方法完成。</p>
<pre>
updateDaysPanel();
updatePassedDaysLabel();
CalendarController.java主要处理具体的业务逻辑，而所使用的一些与具体应用无关的日历算法逻辑则交给CalendarModel.java。
CalendarModel.java
public class CalendarModel {
  private int daytab[][] = {
      { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
      { 0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 } };

  public boolean isLeapYear(int year) {
    return ((year % 4 == 0 &amp;&amp; year % 100 != 0) || year % 400 == 0);
  }

  public int dayOfYear(int day, int month, int year) {
    int leap = isLeapYear(year) ? 1 : 0;
    for (int i = 1; i &lt; month; i++)
      day += daytab[leap][i];
    return day;
  }

  public int daysOfMonth(int month, int year) {
    int leap = isLeapYear(year) ? 1 : 0;
    return daytab[leap][month];
  }

  public int dayOfWeek(int day, int month, int year) {
    if (month == 1) {
      month = 13;
      year--;
    }
    if (month == 2) {
      month = 14;
      year--;
    }
    return (day + 2 * month + 3 * (month + 1) / 5 + year + year / 4 - year
       / 100 + year / 400) % 7 + 1;
  }
}
</pre>
<p>建立一个二维数组，分别表示闰年与非闰年的每月天数。主要方法有：</p>
<ul>
<li>boolean isLeapYear(int year);判断闰年</li>
<li>dayOfYear(int day, int month, int year);计算所提供日期为当前year的第几天</li>
<li>daysOfMonth(int month, int year);返回当前月份的天数</li>
<li>dayOfWeek(int day, int month, int year); 计算某年某月某日是星期几，这里使用了基姆拉尔森计算公式。</li>
</ul>
<p>基姆拉尔森计算公式</p>
<ul>
<li>W= (d+2*m+3*(m+1)/5+y+y/4-y/100+y/400) mod 7</li>
<li>d 天</li>
<li>m 月</li>
<li>y 年</li>
<li>1月2月换算为去年的13 14月计算</li>
<li>w=0是星期一，依次类推。</li>
</ul>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索java<br />
                    ，                日历<br />
                    ，                日期<br />
                                    时间<br />
                                    ，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-13 03:01:56</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%8e%86/" title="日历">日历</a>, <a href="https://www.iamivan.net/tag/%e6%97%b6%e9%97%b4/" title="时间">时间</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e6%9c%9f/" title="日期">日期</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>学习Java中的日期和时间处理及Java日历小程序的编写_java的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWDeYz.html" rel="bookmark">Java中的日期和时间类以及Calendar类用法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java日期和时间类简介 Java 的日期和时间类位于 java.util 包中.利用日期时间类提供的方法,可以获取当前的日期和时间,创建日期和时间参数,计算和比较时间. Date 类 Date 类是 Java 中的日期时间类,其构造方法比较多,下面是常用的两个: Date():使用当前的日期和时间初始化一个对象. Date(long millisec):从1970年01月01日00时(格林威治时间)开始以毫秒计算时间,计算 millisec 毫秒.如果运行 Java 程序的本地时区是北京时区(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1Gw8b.html" rel="bookmark">浅谈javascript中关于日期和时间的基础知识&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面的话 在介绍Date对象之前,首先要先了解关于日期和时间的一些知识.比如,闰年.UTC等等.深入了解这些,有助于更好地理解javascript中的Date对象.本文将介绍javascript关于日期和时间的基础知识 标准时间一般而言的标准时间是指GMT和UTC,以前是GMT,现在是UTC GMT 格林尼治标准时间(GMT)是指位于伦敦郊区的皇家格林尼治天文台的标准时间,因为本初子午线被定义在通过那里的经线 理论上来说,格林尼治标准时间的正午是指当太阳横穿格林尼治子午线时(也就是在格林尼治上空			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZraWz.html" rel="bookmark">详解Java中格式化日期的DateFormat与SimpleDateFormat类&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DateFormat 1. DateFormat 介绍DateFormat 的作用是 格式化并解析&quot;日期/时间&quot;.实际上,它是Date的格式化工具,它能帮助我们格式化Date,进而将Date转换成我们想要的String字符串供我们使用 不过DateFormat的格式化Date的功能有限,没有SimpleDateFormat强大:但DateFormat是SimpleDateFormat的父类.所以,我们先对DateFormat有个整体了解,然后再学习SimpleDateFormat. D			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8VwJ3b.html" rel="bookmark">C&sol;C&plus;&plus;中的日期和时间 time&lowbar;t与struct tm转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1．概念在C/C++中,对字符串的操作有很多值得注意的问题,同样,C/C++对时间的操作也有许多值得大家注意的地方.最近,在技术群中有很多网友也多次问到过C++语言中对时间的操作.获取和显示等等的问题.下面,在这篇文章中,笔者将主要介绍在C/C++中时间和日期的使用方法. 通过学习许多C/C++库,你可以有很多操作.使用时间的方法.但在这之前你需要了解一些&quot;时间&quot;和&quot;日期&quot;的概念,主要有以下几个: Coordinated Universal Time(UTC):协调			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lpd8J4p.html" rel="bookmark">Sql Server中的日期与时间函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Sql Server中的日期与时间函数: 1.  当前系统日期.时间     select getdate()  2. dateadd  在向指定日期加上一段时间的基础上,返回新的 datetime 值:   例如:向日期加上2天    select dateadd(day,2,'2004-10-15')  --返回:2004-10-17 00:00:00.000 3. datediff 返回跨两个指定日期的日期和时间边界数:   select datediff(day,'2004-09-01'			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5AYwWp.html" rel="bookmark">如何在Word 2013文档中插入日期和时间</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用户可以根据实际需要在Word2013文档中插入日期和时间,并且由于所插入的日期和时间代码是从系统中调用的,因此可以在每次打开该Word文档时自动更新时间,或者只在需要更新时间时进行手动更新.在Word2013文档中插入日期和时间的步骤如下所述: 第1步,打开Word2013文档窗口,且换到&quot;插入&quot;功能区.将插入点光标定位到需要插入日期和时间的位置(正文任意位置或页眉页脚中),然后在&quot;插入&quot;区域单击&quot;日期和时间&quot;按钮,如图2013072832所示			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB2Ardb.html" rel="bookmark">Excel2007教程：在工作表中输入日期和时间</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Excel2007基础教程:在工作表中输入日期和时间 Excel 把日期和时间作为特殊类型的数值.这些数值的特点是:它们采用了日期或时间的格式,因为人们发现如果对数值采取正确的格式,将更易于理解.如果处理日期和时间,您就需了解Excel 的日期和时间系统. 3.3 .1 输入日期值 Excel 使用一个序号系统处理日期.Exce l 能够识别的最早日期是1900 年1 月1 日.该日期的序号是1. 1900 年1 月2 日的序号为2 ,依此类推.该系统使在公式中处理日期更为容易.例如,您可以输入			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDAl3Wb.html" rel="bookmark">Excel2007中输入日期和时间技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日期和时间是一种比较特殊的数值,是采用了日期和时间格式的数值,这是为了更便于表格用户的理解. 电子表格中的日期和时间都是利用序列号来存储的,1900 年1月1日在Excel 中的序列号是1,每往后一天序号就加1 .但是这只是为了方便对日期进行处理而设计的, 这样要计算两个是日期之间间隔的天数就很容易了,大部分用户并不关心日期的序列号, 只要能够以系统支持的曰期和时间格式输入就可以了. 在Exce l2007 中,可以输入形如以下几种形式的日期和时间: 2007/1/20:表示的日期是2007 年			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQP0kZz.html" rel="bookmark">在Python的Flask框架中使用日期和时间的教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了在Python的Flask框架中使用日期和时间的教程,包括对各个时区之间转换的一些处理,需要的朋友可以参考下 时间戳的问题 我们的微博应用的一个忽略了很久的问题就是日间和日期的显示. 直到现在,我们在我们的User和Post对象中使用Python它自己的方式来渲染时间对象,但这并不是一个好的解决方案. 考虑下这样的例子.我正在写这篇文章,此时正是12月31号下午3:54.我的时区是PST(或者你们更习惯的:UTC-8). 在Python解释器中运行,我得到下面输出: ? 1			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1ayxM.html" rel="bookmark" class="title">关于防止文件下载盗链之用js来防止文件地址盗链&lpar;二&rpar;</a>
					<div>
						js|下载 Music.htm-----------------&lt;html&gt;&lt;head&gt;&lt;title&gt;PlayMusic&lt;/title&gt;&lt;scri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZLwoM.html" rel="bookmark" class="title">提高医疗网站转化率的有效途径</a>
					<div>
						很多人都问到网站的转化率的问题,尤其是对于医疗网站来说,只有高效的提高转化率,才会产生收益.由此,提高医疗网站转化率的有效途径,成为各位站长所关心的.我做了医疗网站一年多,简单的分享医疗网站高效提高转 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKW2db.html" rel="bookmark" class="title">解决宿主机mac os无法连上虚拟机centos的问题</a>
					<div>
						宿主机: Mac OS 10.9.2 虚拟机: [root@localhost ~]# cat /etc/redhat-release CentOS release 6.4 (Final) [root ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRy4D8b.html" rel="bookmark" class="title">Eclipse中自动重构实现探索</a>
					<div>
						本文用eclipse的自动重构功能对一个程序实例进行重构,目的是探索Eclipse自动重构可以在多大程度上辅助重构这个过程.程序实例使用&lt;Refactoring:Improving the De ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jvk3b.html" rel="bookmark" class="title">SQL Server 2000优化SELECT语句方法</a>
					<div>
						本文是SQL Server SQL语句优化系列文章的第一篇.该系列文章描述了在Micosoft's SQLServer2000关系数据库管理系统中优化SELECT语句的基本技巧,我们讨论的技巧可在Mi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN480b.html" rel="bookmark" class="title">一个较完整的关键字过滤解决方案（上）</a>
					<div>
						如果您希望看到关键字过滤算法的话那么可能就要失望了.博客园中已经有不少关于此类 算法的文章(例如这里和这里),虽然可能无法直接满足特定需求,但是已经足够作为参考 使用.而本文的目的,是给出一个较为完整 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVn264z.html" rel="bookmark" class="title">ps制作逼真漂亮的蓝色五边形钻石</a>
					<div>
						  这篇教程是向脚本之家的朋友分享ps制作逼真漂亮的蓝色五边形钻石方法,教程真的很不错,很值得大家学习,推荐过来,大家一起来学习吧! 方法/步骤 1.在ps软件中,新建一个800*800的文档,背景色 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balVZQz.html" rel="bookmark" class="title">PowerPoint公式编辑器使用</a>
					<div>
						  使用PowerPoint2007及其以上版别中,公式编辑器都是能够直接在菜单里边调用的.但在2003版本中,却找不到公式编辑器,咱们不由会质疑究竟有没有这个功能,其实是有的,只不过需求咱们将其调出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGYx6p.html" rel="bookmark" class="title">一键制作Windows 8启动U盘</a>
					<div>
						今天我们要介绍一款方便的小工具,它可以让你更简单更轻松的创建Windows 8可启动U盘. 小贴士: - 推荐使用4GB或更大的U盘. - 必须以管理员模式运行Windows 8 USB Instal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6Bk2b.html" rel="bookmark" class="title">win8系统桌面回收站图标不显示怎么办？</a>
					<div>
						  在windows系统下,回收站中经常存放着临时删除的文件,用户在将文件误删除后,可通过回收站来找回暂未被清空的数据文件,而一些用户在使用win8系统时,却发现电脑桌面中没有回收站图标,对于该问题很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oqDwb.html" rel="bookmark" class="title">GPT转MBR分区格式图文教程</a>
					<div>
						在转换之前,首先让我们了解一下什么是GPT?为什么要转换? GPT:GUID Partition Table (GUID 分区表 磁盘分区样式支持最大卷为 18 EB (exabytes) 并且每磁盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL3ROb.html" rel="bookmark" class="title">百度云观测提示：恶意内容 被黑（标题）标题被非法篡改，被加入了恶意标题文本</a>
					<div>
						  如果检查了代码没问题那么就考虑是不是有不好的关键词在标题里 类似一些广告的 提示标题被非法篡改,被加入了恶意标题文本这样的 解决方案排查并删除恶意代码或者寻求安全联盟帮助 风险危害 百度搜索结果中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP89WDp.html" rel="bookmark" class="title">代码-image java 数据库 图片</a>
					<div>
						问题描述 image java 数据库 图片 在数据库中用image类型保存的图片, 我想要获取图片并添加到按钮上,java代码应该怎么写 解决方案 DEMOjava读取数据库中的(图像或文件)字段写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGgv7b.html" rel="bookmark" class="title">接电话、拨打电话的流程管理</a>
					<div>
						点击打开链接					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrnyNM.html" rel="bookmark" class="title">三大通用核心套件帮你构建智能运维体系</a>
					<div>
						2017年在线技术分会--运维/DevOps在线技术峰会上,来自阿里基础架构事业部大数据SRE团队的池枫分享了构建通用化智能运维体系的实践.他主要介绍了智能运维体系的设计以及通用核心套件,从T-flo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW510p.html" rel="bookmark" class="title">iOS开发CoreAnimation解读之四&mdash;&mdash;Layer层动画内容</a>
					<div>
						iOS开发CoreAnimation解读之四--Layer层动画内容 一.引言         通过前几篇博客的介绍,我们可以了解到layer层可以设置许多与控件UI相关的属性,并且对于iOS开发,U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV9l5b.html" rel="bookmark" class="title">c-如何用C语言编写代码实现：文件中一行的开头是否与正则表达式&Hat;&dollar;w&lowbar;ang&lbrack;&period;&ast; 相匹配</a>
					<div>
						问题描述 如何用C语言编写代码实现:文件中一行的开头是否与正则表达式^$w_ang[.* 相匹配 如何用C语言编写代码实现:文件中一行的开头是否与正则表达式^$w_ang[.* 相匹配,,,怎么写代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxak8b.html" rel="bookmark" class="title">Common Gui Tools 1&period;1，Java GUI实用小工具集</a>
					<div>
						Common Gui Tools Common Gui Tools 是用java编写,GUI界面的实用小工具集,1.1版有13个小工具: 1,编码转换:Character Converter 2,加密 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NJWaz.html" rel="bookmark" class="title">【独家】一文读懂非关系型数据库（NoSQL）</a>
					<div>
						前言 NoSQL(NoSQL = Not Only SQL ),意即&quot;不仅仅是SQL&quot;. 现代计算系统每天在网络上都会产生庞大的数据量.这些数据有很大一部分是由关系型数据库管理系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoqJOb.html" rel="bookmark" class="title">javascript-如何在只有少数测试数据的情况下，绘制等温线&lpar;求算法&sol;思路&rpar;</a>
					<div>
						问题描述 如何在只有少数测试数据的情况下,绘制等温线(求算法/思路) 布置一定数量的测量点,然后根据测量点给出的温度数据,如何绘制该时刻的等温线求算法或者思路 谢谢					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBmlwM.html" rel="bookmark" class="title">从免费导航事件，看高德用户策略的一成一败</a>
					<div>
						成:紧抓屌丝用户 高德地图打败高德导航虽然上周高德与百度的公关战打得很热闹,但我相信行内人都会看清一点:促使高德导航免费的,不是百度导航:高德导航的真正对手,其实是站在它身边静观其变的高德手机地图.为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl59Gp.html" rel="bookmark" class="title">thinkphp-Fatal error&colon; Class &amp;amp&semi;amp&semi;&num;39&semi;Think&amp;amp&semi;amp&semi;&num;39&semi; not found in</a>
					<div>
						问题描述 Fatal error: Class 'Think' not found in Fatal error: Class 'Think' not found in D:wwwhongmuThin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYAKPp.html" rel="bookmark" class="title">mybatis --XML 映射配置文件</a>
					<div>
						MyBatis 的配置文件包含了影响 MyBatis 行为甚深的设置(settings)和属性(properties)信息.文档的顶层结构如下: configuration 配置 properties ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBd7Db.html" rel="bookmark" class="title">php 操作两个不同编码的数据库</a>
					<div>
						问题描述 php 操作两个不同编码的数据库 我从一个编码规则为GBK的数据库取数据,然后加入一个编码规则为UTF-8的数据库中,如何解决乱码问题 解决方案 mb_convert_encoding( $ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlVWqp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;暗黑流量&rdquo;超大规模DDoS溯源分析</a>
					<div>
						本文讲的是&quot;暗黑流量&quot;超大规模DDoS溯源分析, 一.背景 近日,腾讯云鼎实验室的合作伙伴Panabit于2017年5月26日19点开始,监测到一次大面积网络攻击活动,本次活动呈现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeZavb.html" rel="bookmark" class="title">阿里网络安全&amp;quot&semi;特工&amp;quot&semi; 捕捉数据异常剥去骗子马甲</a>
					<div>
						数万元被骗.假冒淘宝客服.接警地浙江湖州.受害人是新手卖家,几条线索摆在眼前.一边盘算如何顺藤摸瓜,一边赶往办公室,天赞要在今天晨会前巡查最新的安全情报. 天赞这三年几乎没睡过几次好觉. 数万元被骗. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYnQnp.html" rel="bookmark" class="title">文本验证已经过时 神经网络是验证码的大敌</a>
					<div>
						最初的验证码在2000年投入使用,从那时起验证码整体上都大同小异.考虑到验证码主要是一种安全手段,这显然会引发麻烦.毕竟,如果在长达17年的时间里,一项安全技术始终得不到更新,这简直是场灾难,因为这意 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY22Wp.html" rel="bookmark" class="title">越狱大神制作iOS6&sol;iOS7双系统切换工具</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;       上周,我们曾报道了著名越狱黑客Winocm曾神 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M603wyz.html" rel="bookmark" class="title">Win8&period;1系统创建电源计划的方法</a>
					<div>
						1.在桌面模式下右键单击左下角的[开始].    2. 选择[控制面板].    3.选择[硬件和声音].      4.选择[电源选项].    5.选择左侧的[创建电源计划].     6.选择需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLggVAM.html" rel="bookmark" class="title">李毅吧主被指主年入百万</a>
					<div>
						李毅指控吧主靠置顶广告帖捞金 叹旧日&quot;帝吧的内涵和欢乐都已灰飞烟灭&quot; 近期,&quot;屌丝大帝&quot;李毅发布了多条微博,直指有&quot;百度第一贴吧&quot;之称的李毅 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
